<?php
/*
* 2007-2015 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2015 PrestaShop SA
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

/**
 * @since 1.5.0
 */
class TrustPayConfirmPaymentModuleFrontController extends ModuleFrontController
{
    /**
     * @see FrontController::postProcess()
     */
    public function postProcess()
    {
        $cart = $this->context->cart;

        $total = (float)$cart->getOrderTotal(true, Cart::BOTH);

        $suspect = false;

        

    
        if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active) {
            Tools::redirect('index.php?controller=order&step=1');
        }

        // Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
        $authorized = false;
        foreach (Module::getPaymentModules() as $module) {
            if ($module['name'] == 'trustpay') {
                $authorized = true;
                break;
            }
        }

        if (!$authorized) {
            die($this->module->l('This payment method is not available.', 'validation'));
        }

        $customer = new Customer($cart->id_customer);
        if (!Validate::isLoadedObject($customer))
             Tools::redirect('index.php?controller=order&step=1');

        $currency = $this->context->currency;
        
        $mailVars = array(
        //     '{bankwire_owner}' => Configuration::get('BANK_WIRE_OWNER'),
        //     '{bankwire_details}' => nl2br(Configuration::get('BANK_WIRE_DETAILS')),
        //     '{bankwire_address}' => nl2br(Configuration::get('BANK_WIRE_ADDRESS'))
         );

        $status = Tools::getValue('result');
        $merchant_id = Tools::getValue('merchant');
        $transid = Tools::getValue('order');
        $rkey = Tools::getValue('rkey');
        $checksum = Tools::getValue('checksum');

        // $suspect = (md5($status.$merchant_id.$transid.$rkey) != $checksum) ? true : false;
        $newchecksum = md5($status.$merchant_id.$transid.$rkey);
        if(strcmp($newchecksum, $checksum) !== 0) {
            $suspect = "true";
        } else {
            $suspect = "false";
        }
		

        if($suspect == "true") {
            //$this->module->validateOrder($cart->id, Configuration::get('PS_OS_PAYMENT_ERROR'), $total, $this->module->displayName, NULL, $mailVars, (int)$currency->id, false, $customer->secure_key);
            $this->setTemplate('module:trustpay/views/templates/front/payment_return_suspect.tpl');
        }
        else {

            $this->context->smarty->assign([
                //'params' => $_REQUEST,
                'total' => $total,
            ]);


            //$this->setTemplate('payment_return.tpl');
            //$this->setTemplate('module:trustpay/views/templates/front/payment_return.tpl');

            if($status == "Y") {
                $this->module->validateOrder($cart->id, Configuration::get('PS_OS_PAYMENT'), $total, $this->module->displayName, NULL, $mailVars, (int)$currency->id, false, $customer->secure_key);
                Tools::redirect('index.php?controller=order-confirmation&id_cart='.$cart->id.'&id_module='.$this->module->id.'&id_order='.$this->module->currentOrder.'&key='.$customer->secure_key);
            } else {
                $this->setTemplate('module:trustpay/views/templates/front/payment_return_error.tpl');
            }
        }

    }

}
